/* With this program we can build a big base to test the capacity of the
   grid. The test is already made with a big base of 100 fields, 25 characteres
   and 100 records.

   Con este programa podemos construir una gran base de datos para probar
   las capacidades del grid. El test esta pasado con una gran base de datos
   de 100 campos, 25 caracteres por campo y 100 registros

*/


function main( cName, nNumRec, nNumFields  )
Local n, aDbf, n2


if cName == nil
   cName := ".\dbfs\bigbase.dbf"
endif

if nNumRec    == nil; nNumRec    := 100; else ; nNumRec    := val( nNumRec )   ; endif
if nNumFields == nil; nNumFields := 100; else ; nNumFields := val( nNumFields ); endif
cls

if file( ".\dbfs\bigbase.dbf" )
   delete file .\dbfs\bigbase.dbf
endif

        aDbf := {}
        for n := 1 to nNumFields
            AADD(aDbf, { "field" + alltrim(str(n,10)) , "C", 25, 0 })
        next
        //
        DBCREATE( cName, aDbf )

        dbcloseall()

        use ( cName ) ALIAS nueva NEW SHARED

        FOR n := 1 to nNumRec
            nueva->(dbappend())
            rlock()
            for n2 := 1 to nNumFields
              eval( nueva->(fieldblock( fieldname( n2 )) ), replicate( chr( ( n % 24) + 65) , 25 ) )
            next n2
            unlock
            @ 10,10 SAY n
        NEXT

        dbcloseall()

return nil

