#include "fivewin.ch"
#include "..\ch\c5grid.ch"

#define CLR_YELLOW        65535               // RGB( 255, 255,   0 )
#define CLR_RED             128               // RGB( 128,   0,   0 )
#define VK_F2              113        //  0x71

static oWnd

function main()

Local oCol, oHdr
Local cCol
Local n, n2

public oGrid, aTabla := array( 101, 100 )

* define a big base of 100 fields and 100 records.
* define una gran base de 100 campos y 100 registros.


if !file( ".\dbfs\bigbase.dbf" )
   ? "bigbase.dbf not found "
   ? "first make the fillbase program"
   ? "and put bigbase.dbf into the dbfs directory"
   quit
endif


USE dbfs\BIGBASE ALIAS BIGBASE

 for n2 := 1 to 100
     aTabla[ 1, n2 ] := n2
 next

for n := 1 to 100
    for n2 := 2 to 101
       aTabla[ n2, n ] := bigbase -> ( fieldget( n2 - 1 ) )
    next n2
    bigbase->( dbskip(1) )
next n

dbclosearea("bigbase")


DEFINE WINDOW oWnd TITLE "Showing arrays -> from bigbase.dbf"


       @ 10,10 GRID oGrid SIZE 300, 300   ;
               OF oWnd ALIAS "ARRAY"      ;
               VGRID HGRID VSCROLL HSCROLL

       oGrid:SetArray( aTabla )

       for n := 1 to 101

           cCol := alltrim( str( n, 3 ) )

           DEFINE HEADER oHdr TITLE "Columna " + str( n, 3 ) BUTTONLOOK

           TColGrid():New( &(cCol) , , , oHdr , oGrid, , , , , , , , , , , !.F., , , , ,"@E 99,999.99" ,, .F.,, .F., .F., "@E 99,999.99" )

       next


       FILLCOLOR TO oGrid ROWS COLORPANE CLR_RED COLORTEXT CLR_YELLOW ;
               FROM 1 STEPS 2


       SETKEY( VK_F2, {|| oGrid:adelrow() } )


ACTIVATE WINDOW oWnd MAXIMIZED

Return nil


