#include "fivewin.ch"
#include "..\ch\c5grid.ch"

extern GetTextWid


function main()
Local oWnd, oGrid

Local oCol1,  oCol2,  oCol3,  oCol4,  oCol5,  oCol6,  oCol7,  oCol8
Local oHdr1,  oHdr2,  oHdr3,  oHdr4,  oHdr5,  oHdr6,  oHdr7,  oHdr8
Local oFoot1, oFoot2, oFoot3, oFoot4, oFoot5, oFoot6, oFoot7, oFoot8

Local oNegrita, oWingdings, oNormal, oCursiva

DEFINE FONT oNegrita NAME "Arial"         SIZE 0,-14 BOLD
DEFINE FONT oNormal  NAME "Ms Sans Serif" SIZE 0,-10
DEFINE FONT oCursiva NAME "Arial"         SIZE 0,-12 ITALIC

* se define as para poder activar el segundo juego de caracteres    
* it is defined in this way to activate the second set of characters 
*                                                                    

oWingdings := TFont():New( "Wingdings", 0, -18,, .t.,,,,.f.,.f.,.f., 1 )


USE DBFS\basket ALIAS basket SHARED NEW


DEFINE WINDOW oWnd ;
       FROM   10,10 TO 500, 600  PIXEL                        ;
       TITLE  "Prueba de grid en Ventana definiendo columnas" ;
       COLOR  CLR_BLACK, CLR_GREEN                            ;

       @ 10,10 GRID oGrid                                     ;
               OF oWnd                                        ;
               SIZE 480, 280                                  ;
               HGRID VGRID                                    ;
               COLOR CLR_BLACK, CLR_GREEN                     ;
               ALIAS "basket"                                 ;
               FONT  oNormal                                  ;
               FOOTS                                          ;
               NOBORDER                                       ;
               HDRLINES   2                                   ;
               HIGHTLINE 20

               *oGrid:lNoResizeCol := .t.
               *oGrid:lNoDragCol   := .t.         <<<<<<<< NEW

        DEFINE HEADER oHdr1                                   ;
               TITLES " "," "                                 ;
               COLORPANE CLR_GREEN, nRGB( 128,255,128)        ;
               BITMAP   "bmps\barsa.bmp"                      ;
               ALIGNBMP TOP_LEFT

        DEFINE FOOT oFoot1 TITLE "TOTALES :"                  ;
               ALIGN LEFT                                     ;
               COLOR CLR_WHITE, CLR_GREEN

        DEFINE COLUMNA oCol1 OF oGrid                         ;
               HEADER oHdr1                                   ;
               FOOT oFoot1                                    ;
               FONT oNegrita                                  ;
               NOEDITABLE                                     ;
               DATA {|| OemToAnsi(basket->jugador) }          ;
               WIDTH 160

        DEFINE HEADER oHdr2                                   ;
               TITLES , OemToAnsi("Calificacin")             ;
               COLORPANE CLR_GREEN, nRGB( 128,255,128)        ;
               FONTS  , oCursiva


        DEFINE COLUMNA oCol2 OF oGrid                         ;
               HEADER oHdr2                                   ;
               DATA {|| IF( basket->cali == 0, "l", replicate( "", basket->cali)) } ;
               NOEDITABLE                                     ;
               FONT oWingdings                                ;
               WIDTH 70


        DEFINE HEADER oHdr3                                   ;
               TITLES , "T2"                                  ;
               ALIGN CENTER                                   ;
               COLORPANE CLR_GREEN, nRGB( 128,255,128)        ;
               FONTS  , oCursiva

        DEFINE FOOT oFoot3                                    ;
               COLOR CLR_WHITE, CLR_GREEN                     ;
               ALIGN CENTER                                   ;
               BDATA {|| basket->t2_intro }


        DEFINE COLUMNA oCol3 OF oGrid                         ;
               HEADER oHdr3 FOOT oFoot3                       ;
               DATA {||  STR(basket->t2_intenta,2)           +;
                   "/" + STR(basket->t2_intro  ,2)  }         ;
               NOEDITABLE                                     ;
               FONT oNormal                                   ;
               WIDTH 40


        DEFINE HEADER oHdr4                                   ;
               TITLES , "T3"                                  ;
               ALIGN CENTER                                   ;
               COLORPANE CLR_GREEN, nRGB( 128,255,128)        ;
               FONTS  , oCursiva

        DEFINE FOOT oFoot4                                    ;
               COLOR CLR_WHITE, CLR_GREEN                     ;
               ALIGN CENTER                                   ;
               BDATA {|| basket->t3_intro }


        DEFINE COLUMNA oCol4 OF oGrid                         ;
               HEADER oHdr4  FOOT oFoot4                      ;
               DATA {||  STR(basket->t3_intenta,2)           +;
                   "/" + STR(basket->t3_intro  ,2)  }         ;
               NOEDITABLE                                     ;
               FONT oNormal                                   ;
               WIDTH 40

        DEFINE HEADER oHdr5                                   ;
               TITLES , "TL"                                  ;
               ALIGN CENTER                                   ;
               COLORPANE CLR_GREEN, nRGB( 128,255,128)        ;
               FONTS  , oCursiva

        DEFINE FOOT oFoot5                                    ;
               COLOR CLR_WHITE, CLR_GREEN                     ;
               ALIGN CENTER                                   ;
               BDATA {|| basket->tl_intro }


        DEFINE COLUMNA oCol5 OF oGrid                         ;
               HEADER oHdr5 FOOT oFoot5                       ;
               DATA {|| STR(basket->tl_intenta,2)            +;
                   "/" + STR(basket->tl_intro,2)  }           ;
               NOEDITABLE                                     ;
               FONT oNormal                                   ;
               WIDTH 40

        DEFINE HEADER oHdr6                                   ;
               TITLES , "R"                                   ;
               ALIGN CENTER                                   ;
               COLORPANE CLR_GREEN, nRGB( 128,255,128)        ;
               FONTS  , oCursiva

        DEFINE FOOT oFoot6                                    ;
               COLOR CLR_WHITE, CLR_GREEN                     ;
               ALIGN CENTER                                   ;
               BDATA {|| basket->rebotes }

        DEFINE COLUMNA oCol6 OF oGrid                         ;
               HEADER oHdr6 FOOT oFoot6                       ;
               ALIGN CENTER                                   ;
               DATA "basket->rebotes"                         ;
               NOEDITABLE                                     ;
               FONT oNormal                                   ;
               WIDTH 40

        DEFINE HEADER oHdr7                                   ;
               TITLES , "Per"                                 ;
               ALIGN CENTER                                   ;
               COLORPANE CLR_GREEN, nRGB( 128,255,128)        ;
               FONTS  , oCursiva

        DEFINE FOOT oFoot7                                    ;
               COLOR CLR_WHITE, CLR_GREEN                     ;
               ALIGN CENTER                                   ;
               BDATA {|| basket->perdidas }


        DEFINE COLUMNA oCol7 OF oGrid                         ;
               HEADER oHdr7 FOOT oFoot7                       ;
               DATA "basket->perdidas"                        ;
               ALIGN CENTER                                   ;
               FONT oNormal                                   ;
               NOEDITABLE                                     ;
               WIDTH 40

        DEFINE HEADER oHdr8                                   ;
               TITLES , "Ptos."                               ;
               ALIGN CENTER                                   ;
               COLORPANE CLR_GREEN, nRGB( 128,255,128)        ;
               FONTS  , oCursiva

        DEFINE FOOT oFoot8                                    ;
               COLOR CLR_GREEN, nRGB( 128,255,128)            ;
               ALIGN CENTER                                   ;
               FONT oNegrita                                  ;
               BDATA {|| basket->puntos }

        DEFINE COLUMNA oCol8 OF oGrid                         ;
               HEADER oHdr8 FOOT oFoot8                       ;
               DATA "basket->puntos"                          ;
               NOEDITABLE                                     ;
               ALIGN CENTER                                   ;
               WIDTH 40

        FILLCOLOR TO oGrid ROWS                               ;
               COLORPANE nRGB( 128,255,128)                   ;
               COLORTEXT CLR_BLACK                            ;
               FROM 2 STEPS 2

        FILLCOLOR TO oGrid ROWS                               ;
               COLORTEXT CLR_WHITE                            ;
               FROM 1 STEPS 2


ACTIVATE WINDOW oWnd

basket->(dbclosearea())

Return nil

* prueba de grid en ventana definiendo columnas y pies.
* test of grid in window defining columns and feet

