#include "fivewin.ch"
#include "..\ch\c5grid.ch"


/* 6 test

      SET DELETED ON
      INDICE ACTIVO COMPUESTO "FIRST + LAST" FOR !DELETED()
      COLUMNAS CONSTRUIDAS SIN CODEBLOCK
      COLOREADO ALTERNO DE FILAS
>>>   BORRADO DE REGISTROS CON TECLA <SUP>
      ACTUALIZACION AUTOMATICA DEL RANGO EN LA BARRA DE SCROLL VERTICAL
      DIALOGO DESDE RECURSOS
      ACTUALIZACION DE PANTALLA CON TECLA F5
>>>   EDICION DEL REGISTRO EN VENTANA APARTE REFRESCANDO EL GRID AL FINALIZAR

   Los indices han de construirse con la clusula FOR !Deleted() en el
   caso de trabajar con SET DELETED ON.
   Si no se trabajase con indices se mantendr un indice de la siguiente
   forma:

           INDEX ON recno() to <nombre del indice>  FOR !Deleted()

   para que el grid pueda obtener la posicin lgica de cada registro en
   cada momento.

*/


function main()

Local oDlg
Local oGrid, oGrid2
Local oCol1,  oCol2,  oCol3,  oCol4,  oCol5,  oCol6
Local oCol11, oCol22, oCol33, oCol44, oCol55, oCol66
Local oBtn, oBtn2
Local aBmp := {"deleted.bmp","nodelete.bmp"}

Public oFont

DEFINE FONT oFont NAME "Ms Sans Serif" SIZE 5,13


DBUSEAREA( .T., "DBFNTX","dbfs\FIVETEST.dbf", "fivetest", .T. )
index on fivetest->FIRST + fivetest->LAST to rec_orde for !deleted()

* si no se hace as el indice se queda abierto en forma exclusiva
dbcloseall()


DBUSEAREA( .T., "DBFNTX","dbfs\FIVETEST.dbf", "fivetest", .T. )
fivetest->(dbsetindex( "rec_orde" ))


DBUSEAREA( .T., "DBFNTX","dbfs\FIVETEST.dbf", "five2", .T. )
five2->(dbsetindex( "rec_orde" ) )

DEFINE DIALOG oDlg NAME "DIALOG_1" FONT oFont


      REDEFINE GRID oGrid2 ID 102 OF oDlg          ;
               ALIAS "five2"                    ;
               VGRID HGRID VSCROLL HSCROLL         ;
               COLOR CLR_BLACK, RGB( 255,255,128 ) ;
               HDRLINES 1 BAR


       DEFINE COLUMNA oCol11 OF oGrid2               ;
              WIDTH 50                             ;
              DATA {|| five2->(recno()) }      ;
              ALIGN CENTER ;
              NOEDITABLE

       DEFINE COLUMNA oCol22 OF oGrid2 ;
              WIDTH 25 ;
              BITMAP aBmp ;
              BBITMAP if( five2->(deleted()) , 1, 2 ) ;
              ALIGNBMP CENTER ;
              ALIGN CENTER ;
              NOPAINTDATA NOEDITABLE

       DEFINE COLUMNA oCol33 OF oGrid2             ;
              WIDTH 150                          ;
              DATA "five2->FIRST"

       DEFINE COLUMNA oCol44 OF oGrid2             ;
              WIDTH 150                          ;
              DATA "five2->LAST"

       DEFINE COLUMNA oCol55 OF oGrid2             ;
              WIDTH 150                          ;
              DATA "five2->STREET"

       DEFINE COLUMNA oCol66 OF oGrid2             ;
              WIDTH 150                          ;
              DATA "five2->CITY"

       oGrid2:bKeyDown := {|nKey, nFlags| if( nKey == 46, ;
                          (oGrid2:xDelete(),;
                           oGrid2:Refresh()        ),.t.) }


       FILLCOLOR TO oGrid2 ROWS COLORPANE CLR_MAGENTA COLORTEXT CLR_YELLOW STEPS 2

      REDEFINE GRID oGrid ID 101  OF oDlg         ;
               ALIAS "fivetest"                      ;
               VGRID HGRID VSCROLL HSCROLL         ;
               COLOR CLR_BLACK, RGB( 255,255,128 ) ;
               HDRLINES 1


       DEFINE COLUMNA oCol1 OF oGrid               ;
              WIDTH 50                             ;
              DATA {|| fivetest ->(recno()) }      ;
              ALIGN CENTER ;
              NOEDITABLE

       DEFINE COLUMNA oCol2 OF oGrid ;
              WIDTH 25 ;
              BITMAP aBmp ;
              BBITMAP if( fivetest->(deleted()) , 1, 2 ) ;
              ALIGNBMP CENTER ;
              ALIGN CENTER ;
              NOPAINTDATA NOEDITABLE

       DEFINE COLUMNA oCol3 OF oGrid             ;
              WIDTH 150                          ;
              DATA "fivetest->FIRST"

       DEFINE COLUMNA oCol4 OF oGrid             ;
              WIDTH 150                          ;
              DATA "fivetest->LAST"

       DEFINE COLUMNA oCol5 OF oGrid             ;
              WIDTH 150                          ;
              DATA "fivetest->STREET"

       DEFINE COLUMNA oCol6 OF oGrid             ;
              WIDTH 150                          ;
              DATA "fivetest->CITY"

       oGrid:bKeyDown := {|nKey, nFlags| if( nKey == 46, ;
                          (oGrid:xDelete(),;
                           oGrid:Refresh()        ),.t.) }


       FILLCOLOR TO oGrid ROWS COLORPANE CLR_CYAN COLORTEXT CLR_YELLOW STEPS 2


       REDEFINE BUTTON oBtn ID 103 OF oDlg ACTION oDlg:End()

       REDEFINE BUTTON oBtn ID 104 OF oDlg ACTION Editar( oGrid, oGrid2 )


ACTIVATE DIALOG oDlg

dbcloseall()

oFont:End()

return nil


/* efectos de la definicin

   Se utiliza el nuevo mtodo xDelete() y se actualiza con Refresh()
   Cuando se observa que los datos que se estn visualizando estn
   siendo erroneos por que se han borrado desde otra area los registros
   se ha de pulsar la tecla F5 para refrescar los datos o directamente
   refrescar el otro grid en el proceso de borrado.


*/


function editar( oGrid, oGrid2 )
local cAlias := ALIAS()

local cFirst  := ( cAlias ) -> first
local cLast   := ( cAlias ) -> last
local cStreet := ( cAlias ) -> street
local cCity   := ( cAlias ) -> city

local oDlg, oBtn
Local oGet1, oGet2, oGet3, oGet4


DEFINE DIALOG oDlg NAME "DIALOG_2" FONT oFont

       REDEFINE GET oGet1 VAR cFirst  ID 101 OF oDlg
       REDEFINE GET oGet2 VAR cLast   ID 102 OF oDlg
       REDEFINE GET oGet3 VAR cStreet ID 103 OF oDlg
       REDEFINE GET oGet4 VAR cCity   ID 104 OF oDlg

       REDEFINE BUTTON oBtn ID 105 OF oDlg ;
                ACTION ( ( cAlias ) -> ( dbrlock() )     ,;
                         ( cAlias ) -> first  := cFirst  ,;
                         ( cAlias ) -> last   := cLast   ,;
                         ( cAlias ) -> street := cStreet ,;
                         ( cAlias ) -> city   := cCity   ,;
                         ( cAlias ) -> (dbrunlock())     ,;
                       oGrid:Refresh(),oGrid2:Refresh(),;
                       oDlg:End() )

ACTIVATE DIALOG oDlg

return nil





