/*
 Programa Ŀ
   Aplication: class THdrGrid                                             
         File: HEADER.PRG                                                 
       Author: Francisco Garca Fern ndez                                 
     Internet: http://www.arrakis.es/~canal_five/                         
     Internet: http://come.to/canalfive                                   
       E-Mail: canalfive@solution4u.com                                   
         Date: 28-may-1998                                                
         Time: 09:00:00                                                   
      Version: 2.0p                                                       
    Copyright: 1997 by Francisco Garca Fernndez                         

*/

#include "fivewin.ch"

#define ALINEACION {32,33,34,36,37,38,40,41,42,0,16,17}
#define CALIGN {"TOP_LEFT","TOP_CENTER","TOP_RIGHT",;
                "LEFT","CENTER","RIGHT",;
                "BOTTOM_LEFT","BOTTOM_CENTER","BOTTOM_RIGHT",;
                "PLAIN","MULTILINE","MULTICENTER" }

#define DT_EXPANDTABS       64  //  0x0040

CLASS THdrGrid

      DATA aTitles
      DATA aBitmaps, aHBitmaps, aSizesBmps, aBCalcCoor
      DATA nAjusteBmp

      DATA aBVText

      DATA aoFont

      DATA aClrPane, aClrText
      DATA anClrPane           // nmero de brocha a utilizar

      DATA aGrids              // para lineas en la cabecera "NSEW"

      DATA nAjuste
      DATA lVGrid, lHGrid
      DATA lSpand
      DATA lBtnLook

      DATA bAction             // accion a realizar en el dobleclick de la
                               // cabecera

      METHOD New( aTitles, aoFont, aClrPane, aClrText, ;
                  cAjuste, aBitmaps, lVGrid, lHGrid, lSpand,;
                  cAjusteBmp, bAction, lBtnLook, aGrids ) CONSTRUCTOR

      METHOD SetTitle( cTitle, nTitle )

ENDCLASS

**********************************************************************
METHOD New( aTitles, aoFont, aClrPane, aClrText, ;
            cAjuste, aBitmaps, lVGrid, lHGrid, lSpand,;
            cAjusteBmp, bAction, lBtnLook, aGrids )
**********************************************************************


            DEFAULT cAjuste  := "LEFT",;
                    lVGrid     := .f., lHGrid := .f., lSpand := .f.,;
                    cAjusteBmp := "LEFT", ;
                    lBtnLook := .F.


         ::aTitles    := aTitles
         ::aBitmaps   := aBitmaps
         ::aoFont     := aoFont
         ::aClrPane   := aClrPane
         ::aClrText   := aClrText
         ::aGrids     := aGrids

         ::anClrPane  := nil
         ::aHBitmaps  := nil
         ::aSizesBmps := nil

         ::nAjuste    := ALINEACION [ ascan( CALIGN , cAjuste) ] + DT_EXPANDTABS
         ::nAjusteBmp := ascan( CALIGN, cAjusteBmp )
         ::lVGrid     := lVGrid
         ::lHGrid     := lHGrid
         ::lSpand     := lSpand
         ::lBtnLook   := lBtnLook

         ::bAction    := bAction

         /*  {  top_left      {,} ,;
                top_center    {,} ,;
                top_right     {,} ,
                left          {,} ,
                center        {,} ,
                right         {,} ,
                bottom_left   {,} ,
                bottom_center {,} ,
                bottom_right  {,} }
          */

         ::aBCalcCoor := { ;
             { {|nTopCell|  nTopCell  + 3 },;
               {|nLeftCell| nLeftCell + 3 }   } ,;
             { {|nTopCell |  nTopCell  + 3 },;
               {|nLeftCell, oC, nBmp | nLeftCell        + int(oC:nWidth/2) - ::aSizesBmps[nBmp,3] } } ,;
             { {|nTopCell |  nTopCell  + 3 },;
               {|nLeftCell, oC, nBmp | nLeftCell + oC:nWidth               - ::aSizesBmps[nBmp,1] } } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + int( nHRow / 2 ) - ::aSizesBmps[nBmp,4] },;
               {|nLeftCell| nLeftCell + 3 } } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + int( nHRow / 2 ) - ::aSizesBmps[nBmp,4] },;
               {|nLeftCell, oC, nBmp | nLeftCell + int(oC:nWidth/2)        - ::aSizesBmps[nBmp,3] } } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + int( nHRow / 2 ) - ::aSizesBmps[nBmp,4] },;
               {|nLeftCell, oC, nBmp | nLeftCell + oC:nWidth               - ::aSizesBmps[nBmp,1] } } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + nHRow            - ::aSizesBmps[nBmp,2] },;
               {|nLeftCell| nLeftCell + 3 } } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + nHRow            - ::aSizesBmps[nBmp,2] },;
               {|nLeftCell, oC, nBmp | nLeftCell        + int(oC:nWidth/2) - ::aSizesBmps[nBmp,3] } } ,;
             { {|nTopCell,  oC, nBmp, nHrow |  nTopCell + nHRow            - ::aSizesBmps[nBmp,2] },;
               {|nLeftCell, oC, nBmp | nLeftCell + oC:nWidth               - ::aSizesBmps[nBmp,1] } } }



         ::aBVText := { ;
              { | oFont, oC |  int( oFont:nHeight / 2 )  } ,;
              { | oFont, oC |  int( oC:nWidth /2 ) - int( oFont:nHeight / 2 ) },;
              { | oFont, oC |       oC:nWidth      - int( oFont:nHeight / 2 ) } }



Return nil

***********************************
 METHOD SetTitle( cTitle, nTitle )
***********************************

DEFAULT nTitle := 1, cTitle := "---"

::aTitles[nTitle] := cTitle

Return nil


