/*
 Programa Ŀ
   Aplication: class TFoot                                                
         File: FOOT.PRG                                                   
       Author: Francisco Garca Fern ndez                                 
     Internet: http://www.arrakis.es/~canal_five/                         
     Internet: http://come.to/canalfive                                   
       E-Mail: canalfive@solution4u.com                                   
         Date: 25-feb-1998                                                
         Time: 09:00:00                                                   
      Version: 2.0N                                                       
    Copyright: 1997 by Francisco Garca Fernndez                         

*/

#include "fivewin.ch"

#define ALINEACION {32,33,34,36,37,38,40,41,42,0,16}
#define CALIGN {"TOP_LEFT","TOP_CENTER","TOP_RIGHT",;
                "LEFT","CENTER","RIGHT",;
                "BOTTOM_LEFT","BOTTOM_CENTER","BOTTOM_RIGHT",;
                "PLAIN", "MULTILINE" }

CLASS TFoot

      DATA cTitle
      DATA bDato
      DATA oFont
      DATA nClrPane, nClrText, nBClrPane
      DATA nAjuste
      DATA lSpand

      DATA cPicture
      DATA nAcum

      METHOD New( bDato, oFont, nClrPane, nClrText, cAjuste, cTitle,;
                  lSpand, cPicture ) CONSTRUCTOR

ENDCLASS

**************************************************************************
 METHOD New( bDato, oFont, nClrPane, nClrText, cAjuste, cTitle, lSpand, cPicture )
**************************************************************************

     DEFAULT cAjuste  := if( cTitle == nil, "RIGHT", "LEFT" ), lSpand := .f.


    ::cTitle   := cTitle
    * si hay cTitle no se calcularn totales

    ::bDato    := bDato

               /* creo que el codeblock debe especificarse como una operacin
                  a realizar con varios elementos de cada registro, no como
                  una operacin con la base de datos. Con esto se conseguir
                  mayor rapidez al ejecutarse el proceso de totalizacin por
                  parte del grid y no de cada columna en particular. Indepen-
                  dientemente, cada vez que cambie un valor, el proceso de
                  cambio se encargar de actualizar el citado valor. */

    ::oFont    := oFont
    ::nClrPane := nClrPane
    ::nClrText := nClrText
    ::nAjuste  := ALINEACION [ ascan( CALIGN , cAjuste) ]
    ::lSpand   := lSpand
    ::cPicture := cPicture

    ::nBClrPane := nil  // numero de brocha para el fondo

    ::nAcum    := nil

return nil


