#include <WinTen.h>
#include <Windows.h>
#include <ClipApi.h>


CLIPPER xVScrll() // ( hWnd, wRows, nHRow, nRows, lHeader, nHeader )
{
   HWND hWnd     = _parni( 1 );
   WORD wRows    = _parni( 2 );
   int  nHRow    = _parni( 3 );
   int  nRows    = _parni( 4 );
   HDC hDC     = GetDC( hWnd );
   RECT rct;
   BOOL bHeader = _parl( 5 );
   WORD nHeader = _parni( 6 );

   GetClientRect( hWnd, &rct );

   if ( bHeader )
      rct.top    = nHeader + 1;
      rct.bottom = ( nHRow * nRows ) - 1;
      ScrollWindowEx( hWnd, 0, -( nHRow * wRows ), 0, &rct, 0, 0, 0 );
      ReleaseDC( hWnd, hDC );
}

//----------------------------------------------------------------------------//

CLIPPER xHScrll() // ( hWnd, nCols, nLeft, nRight )
{
   HWND hWnd     = _parni( 1 );
   WORD wCols    = _parni( 2 );
   int nLeft   = _parni( 3 );
   int nRight  = _parni( 4 );
   HDC hDC     = GetDC( hWnd );
   RECT rct;

   GetClientRect( hWnd, &rct );

   if ( nLeft ) {
      rct.left = nLeft;
   }

   if ( nRight ) {
      rct.right = nRight;
   }


   ScrollWindowEx( hWnd, wCols, 0, 0, &rct, 0, 0, 0 );


   ReleaseDC( hWnd, hDC );
}

//----------------------------------------------------------------------------//

